/*------------------------------------------------------------------------
 * $Source: /rcs/vwrcs/brtl/bterrmsg.h,v $
 * Checked in by: $Author: ramin $
 * $Date: 1996/05/30 16:00:12 $                   $Revision: 1.4 $
 *
 * Copyright 1987, Techtrol Ltd.
 * Copyright 1990, Visual Edge Software Ltd.
 * -----------------------------------------
 * ALL RIGHTS RESERVED.  This notice is intended as a precaution against
 * inadvertent publication, and shall not be deemed to constitute an
 * acknowledgment that publication has  occurred nor to imply any waiver
 * of confidentiality.  The year included in the notice is the year
 * of the creation of the work.
 *------------------------------------------------------------------------*/
/*------------------------------------------------------------------------
 *
 *         Module Name: bterrmsg.h
 *  Module Description: All trappable error message defines.
 *
 *                Date: April 1996
 *
 *------------------------------------------------------------------------*/
#ifndef BTERRMSG_HEADER
#define BTERRMSG_HEADER

#define TRAP_3_RETURN_WITHOUT_GOSUB       3 /* "Return without GoSub" */
#define TRAP_4_WRONG_NUMBER_OF_DIMENSIONS 4 /* "Wrong number of dimensions" */
#define TRAP_5_ILLEGAL_FUNCTION_CALL      5 /* "Illegal function call" */
#define TRAP_6_VALUE_ABOVE_RANGE          6 /* "Overflow" */
#define TRAP_7_INSUFFICIENT_MEMORY        7 /* "Out of memory" */
#define TRAP_8_VALUE_BELOW_RANGE          8 /* "Underflow" */
#define TRAP_9_ARRAY_SUBSCRIPT_OUT_OF_RANGE  9 /* "Subscript out of range" */
#define TRAP_10_DUPLICATE_DEFINITION     10 /* "Duplicate definition" */
#define TRAP_11_DIVISION_BY_ZERO         11 /* "Division by zero" */
#define TRAP_13_TYPE_MISMATCH            13 /* "Type mismatch" */
#define TRAP_14_CANNOT_ALLOCATE_STRING   14 /* "Out of string space" */
#define TRAP_16_TOO_MANY_TEMP_STRINGS    16 /* "String formula too complex" */
#define TRAP_17_CANT_CONTINUE            17 /* "Can't continue" */
#define TRAP_19_NO_RESUME                19 /* "No Resume" */
#define TRAP_20_RESUME_WITHOUT_ERROR     20 /* "Resume without error" */
#define TRAP_28_INSUFFICIENT_STACK_SPACE 28 /* "Out of stack space" */
#define TRAP_35_SUB_OR_FUNC_NOT_DEFINED  35 /* "Sub or Function not defined" */
#define TRAP_48_ERROR_IN_LOADING_DLL     48 /* "Error in loading DLL" */
#define TRAP_49                          49 /* "Bad DLL calling convention" */
#define TRAP_50_NOT_IMPL_FOR_PLATFORM    50 /* "not implemented for this platform" */
#define TRAP_51_INTERNAL_ERROR           51 /* "Internal error" */
#define TRAP_52_INVALID_FILE_NUMBER      52 /* "Bad file name or number" */
#define TRAP_53_FILE_NOT_FOUND           53 /* "File not found" */
#define TRAP_54_INVALID_FILE_MODE        54 /* "Bad file mode" */
#define TRAP_55_FILE_ALREADY_OPEN        55 /* "File already open" */
#define TRAP_57_DEVICE_IO_ERROR          57 /* "Device I/O error" */
#define TRAP_58_FILE_ALREADY_EXISTS      58 /* "File already exists" */
#define TRAP_59_INVALID_RECORD_LENGTH    59 /* "Bad record length" */
#define TRAP_61_DISK_FULL                61 /* "Disk full" */
#define TRAP_62_INPUT_PAST_END_OF_FILE   62 /* "Input past end of file" */
#define TRAP_63_INVALID_RECORD_NUMBER    63 /* "Bad record number" */
#define TRAP_64_INVALID_FILE_NAME        64 /* "Bad file name" */
#define TRAP_67_TOO_MANY_FILES_OPEN      67 /* "Too many files open" */
#define TRAP_68_DEVICE_UNAVAILABLE       68 /* "Device unavailable" */
#define TRAP_70_PERMISSION_DENIED        70 /* "Permission denied" */
#define TRAP_71_DISK_NOT_READY           71 /* "Disk not ready" */
#define TRAP_74_CANT_RENAME_DIFF_DRIVE   74 /* "Can't rename with different drive" */
#define TRAP_75_PATH_FILE_ACCESS_ERROR   75 /* "Path/File access error" */
#define TRAP_76_PATH_NOT_FOUND           76 /* "Path not found" */
#define TRAP_91_OBJECT_VARIABLE_NOT_SET  91 /* "Object variable not set" */
#define TRAP_92_FOR_LOOP_NOT_INITIALIZED 92 /* "For loop not initialized" */
#define TRAP_93_INVALID_PATTERN          93 /* "Invalid pattern string" */
#define TRAP_94_INVALID_USE_OF_NULL      94 /* "Invalid use of Null" */
#define TRAP_95_CANNOT_UNLOAD_FORM       95 /* "Cannot destroy active form instance" */
#define TRAP_96_BAD_REDIM                96 /* "Cannot use redim on an outside array" */

#define TRAP_260 260 /* "No timer available" */
#define TRAP_280 280 /* "DDE channel not fully closed; awaiting response from foreign application" */
#define TRAP_281 281 /* "No More DDE channels" */
#define TRAP_282 282 /* "No foreign application responded to a DDE initiate" */
#define TRAP_283 283 /* "Multiple applications responded to a DDE initiate" */
#define TRAP_284 284 /* "DDE channel locked" */
#define TRAP_285 285 /* "Foreign application won't perform DDE method or operation" */
#define TRAP_286 286 /* "Timeout while waiting for DDE response" */
#define TRAP_287 287 /* "User pressed Escape Key during DDE operation" */
#define TRAP_288 288 /* "Destination is busy" */
#define TRAP_289 289 /* "Data not provided in DDE operation" */
#define TRAP_290 290 /* "Data in wrong format" */
#define TRAP_291 291 /* "Foreign application quit" */
#define TRAP_292 292 /* "DDE conversation closed or changed" */
#define TRAP_293 293 /* "DDE Method invoked with no channel open" */
#define TRAP_294 294 /* "Invalid DDE Link format" */
#define TRAP_295 295 /* "Message queue filled; DDE message lost" */
#define TRAP_296 296 /* "PasteLink already performed on this control" */
#define TRAP_297 297 /* "Can't set LinkMode; invalid LinkTopic" */
#define TRAP_320 320 /* "Can't use character device names in file names: '%s'" */
#define TRAP_321_INVALID_FILE_FORMAT 321 /* "Invalid file format" */
#define TRAP_340_CA_ELEMENT_DOES_NOT_EXIST 340 /* "Control array element 'x' does not exist" */
#define TRAP_341_INVALID_CONTROL_ARRAY_INDEX 341 /* "Invalid object array index" */
#define TRAP_342_NOT_ENOUGH_ROOM_FOR_CTRL_ARRAY 342 /* "Not enough room to allocate control array '%s'" */
#define TRAP_343_NOT_AN_ARRAY 343 /* "Object not an array" */
#define TRAP_344 344 /* "Must specify index for object array" */
#define TRAP_345 345 /* "Reached limit: cannot create any more controls for this form" */
#define TRAP_360_OBJECT_ALREADY_LOADED 360 /* "Object already loaded" */
#define TRAP_361_CANT_LOAD_OBJECT 361 /* "Can't load or unload this object" */
#define TRAP_362_CANT_UNLOAD_DESIGN_TIME_CONTROL 362 /* "Can't unload controls created at design time" */
#define TRAP_363 363 /* "Custom control '%s' not found" */
#define TRAP_364 364 /* "Object was unloaded" */
#define TRAP_365 365 /* "Unable to unload within this context" */
#define TRAP_366 366 /* "No MDI form available to load" */
#define TRAP_380_INVALID_PROPERTY_VALUE 380 /* "Invalid property value" */
#define TRAP_381_INVALID_PROPERTY_ARRAY_INDEX 381 /* "Invalid property array index" */
#define TRAP_382 382 /* "'%s' property cannot be set at run time" */
#define TRAP_383 383 /* "'%s' property is read-only" */
#define TRAP_384 384 /* "'%s' property can't be modified when form is minimized or maximized" */
#define TRAP_385 385 /* "Must specify index when using property array" */
#define TRAP_386 386 /* "'%s' property not available at run time" */
#define TRAP_387 387 /* "'%s' property can't be set on this control" */
#define TRAP_388 388 /* "Can't set Visible property from a parent menu" */
#define TRAP_389 389 /* "Invalid key" */
#define TRAP_390_NO_DEFINED_VALUE 390 /* "No Defined Value" */
#define TRAP_391 391 /* "Name not available" */
#define TRAP_392 392 /* "MDI child forms cannot be hidden" */
#define TRAP_393 393 /* "'%s' property cannot be read at runtime" */
#define TRAP_394 394 /* "'%s' property is write-only" */
#define TRAP_395 395 /* "Can't use separator bar as menu name" */
#define TRAP_400 400 /* "Form already displayed; can't show modally" */
#define TRAP_401 401 /* "Can't show non-modal form when modal form is displayed" */
#define TRAP_402 402 /* "Must close or hide topmost modal form first" */
#define TRAP_403 403 /* "MDI forms cannot be shown modally" */
#define TRAP_404 404 /* "MDI child forms cannot be shown modally" */
#define TRAP_405 405 /* "Parent of MDI forms cannot be shown" */
#define TRAP_406 406 /* "Form cannot be shown" */
#define TRAP_420_INVALID_OBJECT_REFERENCE 420 /* "Invalid object reference" */
#define TRAP_421 421 /* "Method not applicable for this object" */
#define TRAP_422_PROPERTY_NOT_FOUND    422 /* "Property '%s' not found" */
#define TRAP_423 423 /* "Property or control '%s' not found" */
#define TRAP_424_OBJECT_REQUIRED       424 /* "Object required" */
#define TRAP_425_INVALID_OBJECT_USE    425 /* "Invalid object use" */
#define TRAP_426 426 /* "Only one MDI Form allowed" */
#define TRAP_427 427 /* "Invalid object type: Menu control requiered" */
#define TRAP_428 428 /* "Popup menu must have at least one sub menu" */
#define TRAP_429_OLE_CANT_CREATE_OBJ   429 /* "Cannot create object" */
#define TRAP_436_OLE_CALL_OVERFLOW     436 /* "Method or property call overflow" */
#define TRAP_438_OLE_METHOD_NOT_FOUND  438 /* "Method or property not found" */
#define TRAP_439_OLE_ARG_TYPE_MISMATCH 439 /* "Method or property call type mismatch" */
#define TRAP_450_WRONG_PROPERTY_ACCESS 450 /* "Wrong number of arguments or invalid property '%s' assignment" */
#define TRAP_460 460 /* "Invalid Clipboard format" */
#define TRAP_461 461 /* "Specified format does not match format of data" */
#define TRAP_480 480 /* "Can't create AutoRedraw image" */
#define TRAP_481 481 /* "Invalid picture" */
#define TRAP_482 482 /* "Printer error" */
#define TRAP_520 520 /* "Can't empty Clipboard" */
#define TRAP_521 521 /* "Can't open Clipboard" */

/* 
 * ODBC trappable error messages, ranging from 600 to 648
 */

#define TRAP_600        600     /* */
#define TRAP_601        601     /* */
#define TRAP_602        602     /* General ODBC error: '%s' */
#define TRAP_603        603     /* ODBC - SQLAllocEnv failure */
#define TRAP_604        604     /* ODBC - SQLAllocConnect failure */
#define TRAP_605        605     /* Open Database - invalid connect string */
#define TRAP_606        606     /* ODBC - SQLConnect failure '%s' */
#define TRAP_607        607     /* Access attempted on unopened database */
#define TRAP_608        608     /* ODBC - SQLFreeConnect error */
#define TRAP_609        609     /* */
#define TRAP_610        610     /* ODBC - SQLAllocStmt failure */
#define TRAP_611        611     /* ODBC - SQLTables (TableDefs.Refresh) failure: '%s' */
#define TRAP_612        612     /* ODBC - SQLBindCol failure */
#define TRAP_613        613     /* ODBC - SQLFetch failure: '%s' */
#define TRAP_614        614     /* ODBC - SQLColumns failure: '%s' */
#define TRAP_615        615     /* ODBC - SQLStatistics failure: '%s' */
#define TRAP_616        616     /* */
#define TRAP_617        617     /* */
#define TRAP_618        618     /* ODBC - SQLNumResultCols (Create Dynaset) failure: '%s' */
#define TRAP_619        619     /* ODBC - SQLDescribeCol (Create Dynaset) failure: '%s' */
#define TRAP_620        620     /* Dynaset is open - CreateDynaset method is not allowed */
#define TRAP_621        621     /* */
#define TRAP_622        622     /* */
#define TRAP_623        623     /* */
#define TRAP_624        624     /* */
#define TRAP_625        625     /* */
#define TRAP_626        626     /* Attempt to Move past EOF */
#define TRAP_627        627     /* */
#define TRAP_628        628     /* */
#define TRAP_629        629     /* Warning: '%s' (ODBC - SQLSetConnectOption failure) */
#define TRAP_630        630     /* Property is read-only */
#define TRAP_631        631     /* */
#define TRAP_632        632     /* Update illegal without previous Edit or AddNew method */
#define TRAP_633        633     /* */
#define TRAP_634        634     /* */
#define TRAP_635        635     /* */
#define TRAP_636        636     /* Set field value illegal without previous Edit or AddNew method */
#define TRAP_637        637     /* */
#define TRAP_638        638     /* Access attempted on unopened Dynaset */
#define TRAP_639        639     /* Field type is illegal */
#define TRAP_640        640     /* Field size illegal for specified FieldType */
#define TRAP_641        641     /* '%s' illegal - no current record */
#define TRAP_642        642     /* */
#define TRAP_643        643     /* Property not found */
#define TRAP_644        644     /* */
#define TRAP_645        645     /* */
#define TRAP_646        646     /* GetChunk: Offset/Size argument combination illegal */
#define TRAP_647        647     /* Delete method requires a name argument */
#define TRAP_648        648     /* */

/* 
 * Data Access Trappable error messages, ranging from 3001 to 3299
 */

#define TRAP_3001       3001    /* Invalid Argument */
#define TRAP_3002       3002    /* */
#define TRAP_3003       3003    /* */
#define TRAP_3004       3004    /* Couldn't find database '%s' */
#define TRAP_3005       3005    /* '%s' isn't a valid database name */
#define TRAP_3006       3006    /* */
#define TRAP_3007       3007    /* Couldn't open database '%s' */
#define TRAP_3008       3008    /* */
#define TRAP_3009       3009    /* */
#define TRAP_3010       3010    /* Table '%s' already exists */
#define TRAP_3011       3011    /* Couldn't find object '%s' */
#define TRAP_3012       3012    /* Object '%s' already exists */
#define TRAP_3013       3013    /* */
#define TRAP_3014       3014    /* */
#define TRAP_3015       3015    /* '%s' isn't an index in this table */
#define TRAP_3016       3016    /* Field won't fit in record */
#define TRAP_3017       3017    /* Field length is too long */
#define TRAP_3018       3018    /* Couldn't find field '%s' */
#define TRAP_3019       3019    /* */
#define TRAP_3020       3020    /* Update without AddNew or Edit */
#define TRAP_3021       3021    /* No current record */
#define TRAP_3022       3022    /* */
#define TRAP_3023       3023    /* AddNew or Edit already used */
#define TRAP_3024       3024    /* */
#define TRAP_3025       3025    /* */
#define TRAP_3026       3026    /* */
#define TRAP_3027       3027    /* Couldn't update; database is read-only */
#define TRAP_3028       3028    /* */
#define TRAP_3029       3029    /* */
#define TRAP_3030       3030    /* */
#define TRAP_3031       3031    /* */
#define TRAP_3032       3032    /* */
#define TRAP_3033       3033    /* */
#define TRAP_3034       3034    /* */
#define TRAP_3035       3035    /* out of memory */
#define TRAP_3036       3036    /* */
#define TRAP_3037       3037    /* Can't open any more tables or queries */
#define TRAP_3038       3038    /* out of memory */
#define TRAP_3039       3039    /* */
#define TRAP_3040       3040    /* */
#define TRAP_3041       3041    /* */
#define TRAP_3042       3042    /* */
#define TRAP_3043       3043    /* */
#define TRAP_3044       3044    /* */
#define TRAP_3045       3045    /* */
#define TRAP_3046       3046    /* */
#define TRAP_3047       3047    /* Record is too large */
#define TRAP_3048       3048    /* Can't open any more databases */
#define TRAP_3049       3049    /* */
#define TRAP_3050       3050    /* */
#define TRAP_3051       3051    /* Couldn't open file '%s' */
#define TRAP_3052       3052    /* */
#define TRAP_3053       3053    /* */
#define TRAP_3054       3054    /* */
#define TRAP_3055       3055    /* */
#define TRAP_3056       3056    /* Couldn't repair this database */
#define TRAP_3057       3057    /* */
#define TRAP_3058       3058    /* Can't have Null value in index */
#define TRAP_3059       3059    /* */
#define TRAP_3060       3060    /* Wrong data type for parameter '%s' */
#define TRAP_3061       3061    /* '%s' parameters were expected but only '%s' were supplied */
#define TRAP_3062       3062    /* */
#define TRAP_3063       3063    /* */
#define TRAP_3064       3064    /* Can't open action query '%s' */
#define TRAP_3065       3065    /* Can't execute a non-action query */
#define TRAP_3066       3066    /* Query must have at least one output field */
#define TRAP_3067       3067    /* Query input must contain at least one table or query */
#define TRAP_3068       3068    /* */
#define TRAP_3069       3069    /* */
#define TRAP_3070       3070    /* Can' bind name '%s' */
#define TRAP_3071       3071    /* Can't evaluate expression */
#define TRAP_3072       3072    /* */
#define TRAP_3073       3073    /* Operation must use an updatable query */
#define TRAP_3074       3074    /* Can't repeat table name '%s' in FROM clause */
#define TRAP_3075       3075    /* '%s' in query expression '%s' */
#define TRAP_3076       3076    /* '%s' in criteria expression */
#define TRAP_3077       3077    /* '%s' in expression */
#define TRAP_3078       3078    /* Couldn't find input tabel or query '%s' */
#define TRAP_3079       3079    /* Ambiguous field reference '%s' */
#define TRAP_3080       3080    /* Joined table '%s' not listed in FROM clause */
#define TRAP_3081       3081    /* Can't join more than one table with the same name '%s' */
#define TRAP_3082       3082    /* JOIN operation '%s' refers to a non-joined table */
#define TRAP_3083       3083    /* */
#define TRAP_3084       3084    /* Can't insert into action query */
#define TRAP_3085       3085    /* Undefined function '%s' in expression */
#define TRAP_3086       3086    /* Couldn't delete from specified tables */
#define TRAP_3087       3087    /* Too many expressions in GROUP BY clause */
#define TRAP_3088       3088    /* Too many expressions in ORDER BY clause */
#define TRAP_3089       3089    /* Too many expressions in DISTINCT output */
#define TRAP_3090       3090    /* Resultant table may not have more than one Counter field */
#define TRAP_3091       3091    /* HAVING clause '%s' without grouping or aggregation */
#define TRAP_3092       3092    /* */
#define TRAP_3093       3093    /* ORDER BY clause '%s' conflicts with DISTINCT */
#define TRAP_3094       3094    /* ORDER BY clause '%s' conflicts with GROUP BY claus */
#define TRAP_3095       3095    /* Can't have aggregate function in expression */
#define TRAP_3096       3096    /* Can't have aggregate function in WHERE clause */
#define TRAP_3097       3097    /* Can't have aggregate function in ORDER BY clause */
#define TRAP_3098       3098    /* Can't have aggregate function in GROUP BY clause */
#define TRAP_3099       3099    /* Can't have aggregate function in JOIN operation */
#define TRAP_3100       3100    /* Can't set field '%s' in join key to Null */
#define TRAP_3101       3101    /* Join is broken by value(s) in fields '%s' */
#define TRAP_3102       3102    /* Circular reference caused by '%s' */
#define TRAP_3103       3103    /* Circular reference caused by alias '%s' in query definition ...*/
#define TRAP_3104       3104    /* Can't specify Fixed Column Heading '%s' item in a crosstab query more than once */
#define TRAP_3105       3105    /* Missing destination field name in SELECT INTO statement */
#define TRAP_3106       3106    /* Missing destination field name in UPDATE statement '%s' */
#define TRAP_3107       3107    /* Couldn't insert; no insert permission for table or query '%s' */
#define TRAP_3108       3108    /* Couldn't replace; no replace permission for table or query '%s' */
#define TRAP_3109       3109    /* Couldn't delete; no delete permission for table or query '%s' */
#define TRAP_3110       3110    /* */
#define TRAP_3111       3111    /* */
#define TRAP_3112       3112    /* */
#define TRAP_3113       3113    /* Can't update '%s'; field not updatable */
#define TRAP_3114       3114    /* Can't include Memo or Long Binary when you select unique values '%s' */
#define TRAP_3115       3115    /* Can't include Memo or Long Binary in aggregate argument '%s' */
#define TRAP_3116       3116    /* Can't include Memo or Long Binary in criteria '%s' for aggregate functions */
#define TRAP_3117       3117    /* Can't sort on Memo or Long Binary '%s' */
#define TRAP_3118       3118    /* Can't join on Memo or Long Binary '%s' */
#define TRAP_3119       3119    /* Can't group on Memo or Long Binary '%s' */
#define TRAP_3120       3120    /* Can't group on fields selected with '*' '%s'*/
#define TRAP_3121       3121    /* Can't group on fields selected with '*' */
#define TRAP_3122       3122    /* */
#define TRAP_3123       3123    /* */
#define TRAP_3124       3124    /* */
#define TRAP_3125       3125    /* */
#define TRAP_3126       3126    /* Invalid bracketing of name '%s' */
#define TRAP_3127       3127    /* */
#define TRAP_3128       3128    /* Must specify tables to delete from */
#define TRAP_3129       3129    /* Invalid SQL statement; expected 'DELETE', INSERT', ... */
#define TRAP_3130       3130    /* Syntax error in DELETE statement */
#define TRAP_3131       3131    /* Syntax error in FROM clause */
#define TRAP_3132       3132    /* Syntax error in GROUP BY clause */
#define TRAP_3133       3133    /* Syntax error in HAVING clause */
#define TRAP_3134       3134    /* Syntax error in INSERT statement */
#define TRAP_3135       3135    /* Syntax error in JOIN operation */
#define TRAP_3136       3136    /* Syntax error in LEVEL clause */
#define TRAP_3137       3137    /* Missing semicolon (;) at end of SQL statement */
#define TRAP_3138       3138    /* Syntax error in ORDER BY clause */
#define TRAP_3139       3139    /* Syntax error in PARAMETR clause */
#define TRAP_3140       3140    /* Syntax error in PROCEDURE clause */
#define TRAP_3141       3141    /* Syntax error in SELECT statement */
#define TRAP_3142       3142    /* */
#define TRAP_3143       3143    /* Syntax error in TRANSFORM statement */
#define TRAP_3144       3144    /* Syntax error in UPDATE statement */
#define TRAP_3145       3145    /* Syntax error in WHERE clause */
#define TRAP_3146       3146    /* ODBC--call failed */
#define TRAP_3147       3147    /* */
#define TRAP_3148       3148    /* ODBC--connection failed */
#define TRAP_3149       3149    /* */
#define TRAP_3150       3150    /* */
#define TRAP_3151       3151    /* ODBC--connection to '%s' failed */
#define TRAP_3152       3152    /* */
#define TRAP_3153       3153    /* */
#define TRAP_3154       3154    /* */
#define TRAP_3155       3155    /* ODBC--insert failed */
#define TRAP_3156       3156    /* ODBC--delete failed */
#define TRAP_3157       3157    /* ODBC--update failed */
#define TRAP_3158       3158    /* */
#define TRAP_3159       3159    /* Not a valid bookmark */
#define TRAP_3160       3160    /* Table isn't open */
#define TRAP_3161       3161    /* */
#define TRAP_3162       3162    /* Null is invalid */
#define TRAP_3163       3163    /* */
#define TRAP_3164       3164    /* Couldn't update field */
#define TRAP_3165       3165    /* */
#define TRAP_3166       3166    /* */
#define TRAP_3167       3167    /* Record is deleted */
#define TRAP_3168       3168    /* */
#define TRAP_3169       3169    /* Illegal type in expression */
#define TRAP_3170       3170    /* */
#define TRAP_3171       3171    /* */
#define TRAP_3172       3172    /* */
#define TRAP_3173       3173    /* */
#define TRAP_3174       3174    /* */
#define TRAP_3175       3175    /* */
#define TRAP_3176       3176    /* */
#define TRAP_3177       3177    /* Not a valid table name */
#define TRAP_3178       3178    /* Out of memory */
#define TRAP_3179       3179    /* */
#define TRAP_3180       3180    /* Couldn't write to file '%s' */
#define TRAP_3181       3181    /* Invalid range */
#define TRAP_3182       3182    /* */
#define TRAP_3183       3183    /* */
#define TRAP_3184       3184    /* */
#define TRAP_3185       3185    /* */
#define TRAP_3186       3186    /* */
#define TRAP_3187       3187    /* */
#define TRAP_3188       3188    /* */
#define TRAP_3189       3189    /* */
#define TRAP_3190       3190    /* */
#define TRAP_3191       3191    /* Can't define field more than once */
#define TRAP_3192       3192    /* */
#define TRAP_3193       3193    /* */
#define TRAP_3194       3194    /* */
#define TRAP_3195       3195    /* */
#define TRAP_3196       3196    /* */
#define TRAP_3197       3197    /* */
#define TRAP_3198       3198    /* */
#define TRAP_3199       3199    /* */
#define TRAP_3200       3200    /* */
#define TRAP_3201       3201    /* */
#define TRAP_3202       3202    /* */
#define TRAP_3203       3203    /* */
#define TRAP_3204       3204    /* Database already exists */
#define TRAP_3205       3205    /* */
#define TRAP_3206       3206    /* */
#define TRAP_3207       3207    /* */
#define TRAP_3208       3208    /* */
#define TRAP_3209       3209    /* */
#define TRAP_3210       3210    /* Connect string too long */
#define TRAP_3211       3211    /* */
#define TRAP_3212       3212    /* */
#define TRAP_3213       3213    /* */
#define TRAP_3214       3214    /* */
#define TRAP_3215       3215    /* */
#define TRAP_3216       3216    /* Parameter '%s' specified, where a table name is required */
#define TRAP_3217       3217    /* Parameter '%s' specified where the database name is required */
#define TRAP_3218       3218    /* */
#define TRAP_3219       3219    /* */
#define TRAP_3220       3220    /* */
#define TRAP_3221       3221    /* */
#define TRAP_3222       3222    /* */
#define TRAP_3223       3223    /* '%s' isn't a valid parameter name */
#define TRAP_3224       3224    /* */
#define TRAP_3225       3225    /* */
#define TRAP_3226       3226    /* */
#define TRAP_3227       3227    /* */
#define TRAP_3228       3228    /* */
#define TRAP_3229       3229    /* */
#define TRAP_3230       3230    /* */
#define TRAP_3231       3231    /* */
#define TRAP_3232       3232    /* ODBC--couldn't create table */
#define TRAP_3233       3233    /* */
#define TRAP_3234       3234    /* */
#define TRAP_3235       3235    /* */
#define TRAP_3236       3236    /* ODBC--encountered unexpected Null value */
#define TRAP_3237       3237    /* ODBC--unexpected type */
#define TRAP_3238       3238    /* ODBC--data out of range */
#define TRAP_3239       3239    /* */
#define TRAP_3240       3240    /* */
#define TRAP_3241       3241    /* */
#define TRAP_3242       3242    /* Invalid reference in SELECT statement */
#define TRAP_3243       3243    /* */
#define TRAP_3244       3244    /* */
#define TRAP_3245       3245    /* */
#define TRAP_3246       3246    /* */
#define TRAP_3247       3247    /* */
#define TRAP_3248       3248    /* */
#define TRAP_3249       3249    /* */
#define TRAP_3250       3250    /* Couldn't build key */
#define TRAP_3251       3251    /* */
#define TRAP_3252       3252    /* */
#define TRAP_3253       3253    /* */
#define TRAP_3254       3254    /* */
#define TRAP_3255       3255    /* */
#define TRAP_3256       3256    /* */
#define TRAP_3257       3257    /* */
#define TRAP_3258       3258    /* */
#define TRAP_3259       3259    /* Invalid field data type */
#define TRAP_3260       3260    /* */
#define TRAP_3261       3261    /* */
#define TRAP_3262       3262    /* */
#define TRAP_3263       3263    /* Invalid database object */
#define TRAP_3264       3264    /* No fields defined - cannot append table */
#define TRAP_3265       3265    /* Name not found in this collection */
#define TRAP_3266       3266    /* Append illegal - Field is part of a TableDefs collection */
#define TRAP_3267       3267    /* Property value only valid when Field is part of a recordset */
#define TRAP_3268       3268    /* */
#define TRAP_3269       3269    /* Append illegal - Index is part of a TableDefs Collection */
#define TRAP_3270       3270    /* Property not found */
#define TRAP_3271       3271    /* Invalid property value */
#define TRAP_3272       3272    /* */
#define TRAP_3273       3273    /* Method not applicable for this object */
#define TRAP_3274       3274    /* */
#define TRAP_3275       3275    /* */
#define TRAP_3276       3276    /* Invalid database ID */
#define TRAP_3277       3277    /* Can't have more than 10 fields in an index */
#define TRAP_3278       3278    /* */
#define TRAP_3279       3279    /* */
#define TRAP_3280       3280    /* Can't delete field that is part of an index */
#define TRAP_3281       3281    /* */
#define TRAP_3282       3282    /* */
#define TRAP_3283       3283    /* Primary key already exists */
#define TRAP_3284       3284    /* Index already exists */
#define TRAP_3285       3285    /* Invalid index definition */
#define TRAP_3286       3286    /* */
#define TRAP_3287       3287    /* */
#define TRAP_3288       3288    /* */
#define TRAP_3289       3289    /* */
#define TRAP_3290       3290    /* */
#define TRAP_3291       3291    /* */
#define TRAP_3292       3292    /* */
#define TRAP_3293       3293    /* */
#define TRAP_3294       3294    /* */
#define TRAP_3295       3295    /* */
#define TRAP_3296       3296    /* */
#define TRAP_3297       3297    /* */
#define TRAP_3298       3298    /* */
#define TRAP_3299       3299    /* */

/* FileSelectionBox error(s) */
#define TRAP_20476 20476 /* "Selected file name is too large for current buffer size. Use MaxFileSize to increase the file name storage buffer." */

/* Ole Errors */
#define TRAP_31004 31004 /* "No Object" */

#define TRAP_30000 30000 /* "Cannot use RemoveItem on a fix row" */
#define TRAP_30001 30001 /* "Cannot use AddItem on a fix row" */
#define TRAP_30002 30002 /* "Grid does not contain that row" */
#define TRAP_30009 30009 /* "Row value is not valid" */
#define TRAP_30010 30010 /* "Column value is not valid" */
#define TRAP_30015 30015 /* "Cannot remove last non-fixed row" */

#define TRAP_32755_CD_CANCEL 32755 /* "Cancel was selected" */

#endif
